function [ X ] = inverzeC( A )
% Vpoet inverzn matice pomoc LU rozkladu s stenou pivotac
% Pro vpoet je vyuit algoritmus dle Du Croz, Higham: Stability of 
% methods for matrix inversion, Method C
%
%   [ X ] = inverzeC( A )
%   Vstup:  A ... regulrn matice n x n
%   Vstup: X ... inverzn matice A^-1
%
%   Datum posledn pravy: 16.8.2015, KF

[A, p] = luRozklad(A);
[n, ~] = size(A);
X = eye(n);
for k = n : -1 : 1
    X(k + 1 : n, k) = -X(k + 1 : n, k + 1 : n) * A(k + 1 : n, k);
    X(k, k + 1 : n) = -A(k, k + 1 : n) * X(k + 1 : n, k + 1 : n) / A(k, k);
    X(k, k) = 1 / A(k, k) - X(k, k + 1 : n) * A(k + 1 : n, k);
end
r(p) = 1 : n;
X = X(:, r);
end

