function [ X ] = pinvHR( A, tol )
% Moore-Penroseova inverze za vyuit hodnostnho rozkladu matice
%
%   [ X ] = pinvHR( A, tol )
%   Vstup:  A ... matice m x n
%           tol ... tolerance pro rozpoznn nuly
%   Vstup: X ... Moore-Penroseova inverze matice A
%
%   Datum posledn pravy: 8.8.2015, KF

try
[B, C] = hodRozklad(A, tol);
catch
    [m, n] = size(A);
    X = zeros(n, m);
    return
end
X = C' / (B' * A * C') * B';
end

