function [ a ] = polynomFit( x, y, p )
% Aproximace polynomem
%
%   [ a ] = polynomFit( x, y, p )
%   Vstup:  x ... vektor souadnic x vstupnch dat
%           y ... vektor souadnic y vstupnch dat
%           p ... stupe polynomu
%   Vstup: a ... koeficinty hledanho polynomu,
%                 a(1) + a(2) * x + a(3) * x^2 + ... + a(p + 1) * x^p
%
%   Datum posledn pravy: 1.11.2015, KF

m = length(x);
n = length(y);
if m ~= n
    error('Vektory x a y musej mt stejnou dlku.')
end
if p >= m
    warning(['Zadan stupe polynomu je stejn nebo vt ne poet ' ...
    'datovch bod, een nebude jednoznan.'])
end
% Konstrukce matice A (Vandermondova matice)
A = zeros(m, p + 1);
for i = 1 : m
    A(i, 1 : p + 1) = x(i) .^ (0 : p);
end
% een ve smyslu nejmench tverc
a = pinvSvd(A, max(size(A)) * norm(A) * eps) * y(:);
end

